<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="grid">
    <div class="col-12">
        <div class="card">
            <h5 class="text-blue-500 font-bold">รายงานการเปิดสล็อต</h5>
            <p-table #pnl [value]="slots" scrollDirection="both" [paginator]="true" [rows]="10" [scrollable]="true"
                [showCurrentPageReport]="true" styleClass="mt-3" responsiveLayout="scroll" [rowHover]="true"
                currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
                [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['slot_name','service_name']">
                <ng-template pTemplate="caption">
                    <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                        <div class="grid formgrid pl-1 gap-2">
                            <div class="">
                                <div class="text">From</div>
                                <p-calendar [(ngModel)]="dateFrom" [showIcon]="true" [readonlyInput]="true" [showButtonBar]="true"
                                    [monthNavigator]="true" [yearNavigator]="true" yearRange="1900:2050" [locale]="locale"
                                    [dateFormat]="'dd/mm/yy'"></p-calendar>
                            </div>
                            <div class="">
                                <div class="text">To</div>
                                <p-calendar [(ngModel)]="dateTo" [showIcon]="true" [readonlyInput]="true" [showButtonBar]="true"
                                    [monthNavigator]="true" [yearNavigator]="true" yearRange="1900:2050" [locale]="locale"
                                    [dateFormat]="'dd/mm/yy'"></p-calendar>
                                <button pButton pRipple type="button" label="Search" class="p-button-sm p-button-info mx-2"
                                (click)="searchData()">
                                    <i class="pi pi-search mx-2 text-xl"></i>
                                </button>
                            </div>
                        </div>
                        <div class="">
                            <button pButton pRipple type="button" label="Export" (click)="exportExcel()"
                                class="p-button-sm p-button-success">
                                <i class="pi pi-download mx-2 text-xl"></i>
                            </button>
                        </div>
                    </div>
                </ng-template>
                <ng-template pTemplate="header">
                    <tr>
                        <th class="text-center">ลำดับ</th>
                        <th pSortableColumn="service_name">หน่วยบริการ</th>
                        <th pSortableColumn="service_name">คลินิก</th>
                        <th pSortableColumn="service_type_name">บริการ</th>
                        <th pSortableColumn="slot_name">ชื่อสลอต <p-sortIcon field="slot_name"></p-sortIcon></th>
                        <th pSortableColumn="slot_date">วันที่ <p-sortIcon field="slot_date"></p-sortIcon></th>
                        <th pSortableColumn="period_name">ช่วงเวลา</th>
                        <th class="text-center" pSortableColumn="total_slot_per_period">จำนวน</th>
                    </tr>
                </ng-template>
                <ng-template pTemplate="body" let-slots let-i="rowIndex">
                    <tr>
                        <td class="text-center">{{i+1}}</td>
                        <td>{{slots.hospital_name}}</td>
                        <td>{{slots.service_name}}</td>
                        <td>{{slots.service_type_name}}</td>
                        <td>{{slots.slot_name}}</td>
                        <td>{{thaiDateFormat(slots.slot_date)}}</td>
                        <td>{{slots.period_name}}</td>
                        <td class="text-center">{{slots.total_slot_per_period}}</td>  
                </ng-template>
            </p-table>
        </div>
    </div>
</div>